unit PlgInMainAppUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ComCtrls,   PlugInInterfaceUnit;

type
  TForm1 = class(TForm, IapplicationPluginInterface)
    MainMenu: TMainMenu;
    MenuPlugIn: TMenuItem;
    btnLoad: TButton;
    StatusBar1: TStatusBar;
    procedure btnLoadClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    FPlugins: array of THandle;
    FPlugInList: Tlist;
    Procedure LoadPLugins;
    Procedure UnLoadPlugins;
  protected
   function getAppStatus(var statusbar: TStatusBar): Boolean;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}



procedure TForm1.btnLoadClick(Sender: TObject);
begin
  LoadPlugIns;
  BtnLoad.Visible := False;
end;

procedure TForm1.LoadPLugins;
var
  fileName: string;
  searchRec: TSearchRec;
  IFace : IplugInInterface;
  cls   : TPluginClass;
  cs: TComponent;
  desc  : string;
  Status: Integer;
Begin
  // Find Plugin Packages
  fileName := ExtractFilePath(ParamStr(0)) + 'PLG*.BPL';
  Status := FindFirst(fileName, faAnyFile, SearchRec);
  while Status = 0 do begin
     setLength(FPlugins, FpluginList.Count + 1);
     // Load th found Plugin and store its handle
     FPlugins[FPluginList.Count] := LoadPackage(SearchRec.Name);
     desc := GetPackageDescription(pChar(SearchRec.Name));
     // Call GetClass to obtain the class from the class name
     cls := TPluginClass(GetClass(desc));
     if Assigned(cls) then begin
       //Create an instace of the plugin class
       cs := cls.Create(self);
       if cs.GetInterface(IPluginInterface, IFace) then begin
         IFace.Init(Self);
         IFace.GetMenu(menuPlugIn);
       end;
       FPluginList.Add(cs);

    end;
    //Look for the next plugin
     Status := findNext(SearchRec);
  end;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FplugInList := TList.Create;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  UnloadPLugins;
  FPlugInList.Free;
end;

procedure TForm1.UnLoadPlugins;
Var
  i : Integer;
begin
  //Free each Plugin and then unload its package
  for i := 0 to FPluginList.Count -1 do begin
    Tcomponent(FPluginList[i]).Free;
    UnregisterModuleClasses(HINST(FPlugins[i]));
    UnLoadPackage(HINST(FPlugins[i]));
  end;
end;

function TForm1.getAppStatus(var statusbar: TStatusBar): Boolean;
begin
  statusBar := statusbar1;
  Result := True;
end;

end.
